#include <stdio.h>
#include <timers.h>
#include <delays.h>
#include <usart.h>
#include <math.h>
#include "OS_CPU.h"
#include  "includes.h"

//#define TEST1
#define TEST2
//#define TEST3
//#define UART 1
#ifdef TEST1
OS_STK  TestTaskStk[256];
OS_STK  TestTask2Stk[256];
#endif
#ifdef TEST2
OS_STK  TestTaskStk[256];
OS_STK  TestTask2Stk[256];
#endif
#ifdef TEST3
OS_STK  TestTaskStk[256];
OS_STK  TestTask2Stk[256];
OS_STK  TestTask3Stk[256];
#endif
void TestTask2(void *pdata);
void TestTask(void *pdata);
#ifdef TEST3
void TestTask3(void *pdata);
#endif

#ifdef UART
void outputFloat(float number, ram char *ptr, char *task);
ram char *ram_ptr1;
ram char *ram_ptr2;
ram char *ram_ptr3;
char output1[16];
char output2[16];
char output3[16];
char task1[] = "Task1";
char task2[] = "Task2";
char task3[] = "Task3";
#else
void outputFloat(float number);
#endif

#if OS_CRITICAL_METHOD == 3                      /* Allocate storage for CPU status register           */
    OS_CPU_SR  cpu_sr = 0;
#endif

#ifdef UART
void outputFloat(float number, ram char *ptr, char *task) {
  	int intValue;
    int decValue;
	float mantissa;
	// to convert a float to the string, we take the whole number and store it in a variable
	// then we take the mantissa by subtracting the whole number from the float value
	// multply the mantissa by 1000 to get 3 decimial digits, and then truncate the mantissa
	// by casting to a integer
    intValue = (int)number;
	mantissa = number - intValue;
	mantissa = mantissa * 1000;
	decValue = (int)mantissa;
	sprintf(ptr, "%s: %d.%d\r", task, intValue, decValue);	
}
#else
void outputFloat(float number)
{
    int intValue;
    int decValue;
	float mantissa;
	// to convert a float to the string, we take the whole number and store it in a variable
	// then we take the mantissa by subtracting the whole number from the float value
	// multply the mantissa by 1000 to get 3 decimial digits, and then truncate the mantissa
	// by casting to a integer
    intValue = (int)number;
	mantissa = number - intValue;
	mantissa = mantissa * 1000;
	decValue = (int)mantissa;
	printf("%d.%d\n", intValue, decValue);
}
#endif

#ifdef TEST1
void TestTask(void *pdata)
{

	float a = 0.00f;
	float n = 1.25f;
	float m = 2.0f;
	unsigned int i = 0;

    OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_1);
    WriteTimer0(-10000);

	while(1) {
	
		a = n*m/1.23/.856;
		if(a > 32767) {
			a = 0;	
			m = 2.0f;
		}
		else {
			m = a;
		}
		#ifdef UART
	
			ram_ptr1 = &output1[0];
			OS_ENTER_CRITICAL();
			outputFloat(a, ram_ptr1, &task1[0]);
			putsUSART(ram_ptr1);
			OS_EXIT_CRITICAL();				
		#else
		printf("Task1: ");
		outputFloat(a);
		#endif		
		OSTimeDly(100);

	}
}

void TestTask2(void *pdata)
{


	float a = 0.00f;
	float m = 6453.3719f;
	float n = 3.657f;
	float x = 100.00f;
	while(1) {

		a = fmod(m, n);
		m = m - x;
		if(m < 1) {
			m = 6453.3719;
		}
		#ifdef UART
			ram_ptr2 = &output2[0];
			OS_ENTER_CRITICAL();
			outputFloat(a, ram_ptr2, &task2[0]);
			putsUSART(ram_ptr2);
			OS_EXIT_CRITICAL();
			
		#else
			printf("Task2: ");
			outputFloat(a);
		#endif
		OSTimeDly(100);	
	}
}
#endif

#ifdef TEST2
void TestTask(void *pdata) {
	float a = 0.00f;
	float m = 2.0f;
	float n = 1.25f;
	OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_1);
    WriteTimer0(-10000);
	while(1) {
		a = pow(m,n);
		if(a > 32767) {
			a = 0.00f;
			m = 2.0f;
		}
		else {
			m = a;
		}

		#ifdef UART
			ram_ptr1 = &output1[0];
			OS_ENTER_CRITICAL();
			outputFloat(a, ram_ptr1, &task1[0]);
			putsUSART(ram_ptr1);
			OS_EXIT_CRITICAL();
			
		#else
			printf("Task1: ");
			outputFloat(a);
		#endif
		OSTimeDly(100);
	}

}

void TestTask2(void *pdata) {
	float a = 0.00f;
	float m = 3.0f;
	float n = 2.789f;
	while(1) {
		a = pow(m,n);
		if(a > 32767) {
			a = 0.00f;
			m = 3.0f;
		}
		else {
			m = a;
		}	
		#ifdef UART
			ram_ptr2 = &output2[0];
			OS_ENTER_CRITICAL();
			outputFloat(a, ram_ptr2, &task2[0]);
			putsUSART(ram_ptr2);
			OS_EXIT_CRITICAL();
			
		#else
			printf("Task2: ");
			outputFloat(a);
		#endif
		OSTimeDly(100);
	}
}
#endif


#ifdef TEST3
void TestTask(void *pdata) {
	float a = 0.00f;
	float x = 3.122f;
	float y = 1.003f;
	int i = 0;
	OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_1);
    WriteTimer0(-10000);
	while(1) {
		for(i = 0; i < 10; i++) {
			a = pow(x,y);
			if(x > 32767) {
				x = 3.122f;
			}
			else {
				x = a;
			}			
		}		
		#ifdef UART
			ram_ptr1 = &output1[0];
			OS_ENTER_CRITICAL();
			outputFloat(a, ram_ptr1, &task1[0]);
			putsUSART(ram_ptr1);
			OS_EXIT_CRITICAL();
			
		#else
			printf("Task1: ");
			outputFloat(a);
		#endif
		OSTimeDly(100);
	}
	
}

void TestTask2(void *pdata) {
	float a = 0.00f;
	float x = 1.1523f;
	float pi = 3.1416f;
	int r = 0;
	while(1) {
		a = pi * pow(x, 2.0f);
		r = rand();
		if(r < 16384) {
			OSTaskSuspend(9);
		}
		if(a > 32767) {
			a = 0.00f;
			x = 1.1523f;	
		}	
		else {
			x = a;	
		}
		#ifdef UART
			ram_ptr2 = &output2[0];
			OS_ENTER_CRITICAL();
			outputFloat(a, ram_ptr2, &task2[0]);
			putsUSART(ram_ptr2);
			OS_EXIT_CRITICAL();
			
		#else
			printf("Task2: ");
			outputFloat(a);
		#endif
		OSTimeDly(100);		
	}
	
}

void TestTask3(void *pdata) {
	float a = 0.00f;
	float x = 9998.551f;
	while(1) {
		a = log(x)/1.25;
		if(a < 0) {
			x = 9998.551f;
		}	
		else {
			x = a;	
		}
		OSTaskResume(9);
		#ifdef UART
			ram_ptr3 = &output3[0];
			OS_ENTER_CRITICAL();
			outputFloat(a, ram_ptr3, &task3[0]);
			putsUSART(ram_ptr3);
			OS_EXIT_CRITICAL();
			
		#else
			printf("Task3: ");
			outputFloat(a);
		#endif
		OSTimeDly(100);				
	}
	
}
#endif
void main (void)
{	
	#ifdef UART
	OpenUSART (USART_TX_INT_OFF &
             USART_RX_INT_OFF &
             USART_ASYNCH_MODE &
             USART_EIGHT_BIT &
             USART_CONT_RX &
             USART_BRGH_HIGH, 129);
    #endif 

    INTCONbits.GIEH = 0;
    OSInit();

	OSTaskCreate(TestTask, (void *)NULL, &TestTaskStk[0], 8);
    OSTaskCreate(TestTask2, (void *)NULL, &TestTask2Stk[0], 9);
    #ifdef TEST3
    OSTaskCreate(TestTask3, (void *)NULL, &TestTask3Stk[0], 10);
    #endif
    OSStart();
}

